<?php

/*
   message.php3
   
   IMP v1.5
   Copywrite 1998 Charles J. Hagenbuch <chuck@osmos.ml.org>
   
   This code is under the GNU Public License
   See the file COPYING in this directory
*/
  
  error_reporting(1);            /* surpress imap_stream errors, etc.   */
  require ('lib/imp.lib.php3');  /* IMPlib is the IMP function library  */
  dl($path_to_imap);             /* load the imap module                */
  header('Expires: 120');        /* make the page expire in 2 minutes   */
  
  $user    = getuser();
  $pass    = getpass();
  $folders = getfldr();
  $server  = getsrvr();
  if (!$mailbox) { $mailbox = 'INBOX'; }
  $current_mbox = eregi_replace("{$server}$folders/*", '', $mailbox);
  
  $mbox = validate_login($server, $mailbox, $user, $pass);
  
  
  /* Run through action handlers */
  
  /* Actions:
     0 - nothing
     1 - delete message
  */
  
  if (isset($action)) {
    switch ($action) {
      case 0:
        break;
      
      case 1:
        if ($index && $mailbox) {
	  if (!(imap_delete($mbox, $index))) {
	    $errormsg = '<tr><th colspan=2>An error occured; your message has not been deleted.</td></tr>';
	  }
	  $index++;
	}
	break;
    }
  }
  
  
  /* parse MIME header info */
  
  $structure = imap_fetchstructure($mbox, $index);
  $num_parts = count($structure->parts);
  
  if ($bodypart < 1) {$bodypart = 1;}
  if ($num_parts > 0) {
    $j = 1;
    
    while ($j <= $num_parts) {
      $part = $structure->parts[$j];
      $size = $part->bytes;
      $ksize = sprintf ("%0.2f",$size / 1024);
      $encoding = $part->encoding;
      
      if ($part->ifdparametres) {
        $parameters = $part->dparametres;
	$name = $parameters[0]->value;
      }
      
      elseif ($part->ifparametres) {
        $parameters = $part->parametres;
	$name = $parameters[0]->value;
      }
      
      if (!$parameters[0]->value) { $name = 'attachment ' . $j; }
      
      if ($size != 0) {
        $atc .= "<a href=view.php3?mailbox=$mailbox&index=$index&bodypart=$j&action=1>$name</a> - ";
	$atc .= $ksize . 'kB';
	
	if ($encoding == 3) { $atc .= " - MIME 1.0 Encoding"; }
	
	$atc .= " <a href=view.php3?mailbox=$mailbox&index=$index&bodypart=$j&action=1>(download)</a><br>";
      }
      
      $j++;
    }
  }
  
  /* get and format the main body part */
  $msg = htmlentities(fill_paragraphs(imap_fetchbody($mbox, $index, $bodypart)));
  
  $title = "$mailbox: $subject";
  $header_template = file('templates/generic-header.inc');
  $header_template = implode($header_template, '');
  fill_template($header_template, '$title, $errormsg');	
  
  $prev = $index - 1;
  $next = $index + 1;
  if ($index != imap_num_msg($mbox)) { $del_target = 'message.php3';
                                       $del_ident  = 'index'; }
  else { $del_target = 'mailbox.php3';
         $del_ident  = 'indices'; }
  
  $navbar_template = file('templates/message.php3-navbar.inc');
  $navbar_template = implode($navbar_template, '');
  
  fill_template($navbar_template, '$del_target, $del_ident, $index, $mailbox, $index, $bodypart, $start, $current_mbox, $prev, $next, $mbox');
  
  $h = imap_header($mbox, $index);
  
  $dat = htmlentities(chop($h->date ));
  $to  = htmlentities(chop($h->toaddress ));
  $frm = htmlentities(chop($h->fromaddress ));
  $cc  = htmlentities(chop($h->ccaddress ));
  $rep = htmlentities(chop($h->reply_toaddress ));
  $sub = htmlentities(chop($h->subject ));
  
  include('templates/message.php3-headers.inc');
  
  $msg = eregi_replace("(http|https|ftp)://([-=%_a-zA-Z0-9\./~\?]+)", "<a href=\"\\1://\\2\" target=\"_blank\">\\1://\\2</a>", $msg);
  include('templates/message.php3-message.inc');
  
  fill_template($navbar_template, '$del_target, $del_ident, $index, $mailbox, $index, $bodypart, $start, $current_mbox, $prev, $next, $mbox');
  
  $footer_template = file('templates/generic-footer.inc');
  $footer_template = implode($footer_template, '');
  fill_template($footer_template, '$mbox');
?>
